/** Programa que realiza una lista simplemente 
    ligada y la ordena

  Fraga 06.07.2023
**/
#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
	int x, y;          // El contenido del nodo
	struct nodo *sig;  // El punto al nodo siguiente
} NODO;


NODO * crea_nodo( int a,  int b )
{
	NODO *ptr;
	int i;

	ptr = (NODO *) malloc( sizeof(NODO) );
	if ( ptr == NULL ) {
		fprintf( stderr, "ERROR: no hay memoria\n" );
		exit(1);
	}

	ptr -> x = a;
	ptr -> y = b;
	ptr -> sig = NULL;

	return ptr;
}

void insertar_nodo( NODO **plista, NODO * ptr )
{
	// El primer nodo insertado en la lista
	if( *plista == NULL ) {
		*plista = ptr;
	}
	else {
		ptr -> sig = *plista;
		*plista = ptr;
	}
}

void recorrer_lista( NODO *lista )
{
	while( lista != NULL ) {
		printf("%d %d\n", lista->x, lista->y );
		lista = lista->sig;
	}
}

void limpiar_lista( NODO **plista )
{
	NODO * ptr;

	ptr = *plista;
	while( ptr != NULL ) {
		*plista = (*plista)-> sig;
		free( ptr );
		ptr = *plista;
	}
}

int main( )
{
	NODO *lista=NULL;
	NODO *pnodo;

	pnodo = crea_nodo( 1, 3 );
	insertar_nodo( &lista, pnodo );

	pnodo = crea_nodo( 3, 3 );
	insertar_nodo( &lista, pnodo );

	pnodo = crea_nodo( 10, 2 );
	insertar_nodo( &lista, pnodo );

	pnodo = crea_nodo( 30, 8 );
	insertar_nodo( &lista, pnodo );

	recorrer_lista( lista );

	limpiar_lista( &lista );

	return 0;
}
